Ubuntu

Don't create windows over the launcher

Reported by David Prieto on 2010-12-11
190
This bug affects 37 people
Affects Status Importance Assigned to Milestone
Unity
Medium
Alex Launi
unity-2d
High
Olivier Tilloy
compiz (Ubuntu)
Medium
Unassigned
metacity (Ubuntu)
Undecided
Unassigned
unity-2d (Ubuntu)
Undecided
Unassigned
unity (Ubuntu)
Medium
Alex Launi

Bug Description

Binary package hint: unity

Now that Unity has intellihide, when I open a window the system seems to think that the space over Unity's launcher is free, and opens some windows on it, therefore hiding the launcher.

I don't think this should happen. The launcher should hide if the user moves a window over it, but not without user intervention.

Omer Akram (om26er) wrote :

this is something i would have reported if you had not ;)

Changed in unity (Ubuntu):
status: New → Confirmed
Changed in unity:
status: New → Confirmed
Hernando Torque (htorque) wrote :

Workaround: start ccsm > "Place Windows" plugin > set "Placement Mode" to "Centered".

On Sat, Dec 11, 2010 at 6:10 PM, Hernando Torque
<email address hidden> wrote:
> Workaround: start ccsm > "Place Windows" plugin > set "Placement Mode"
> to "Centered".
>
> --
> You received this bug notification because you are a member of Unity
> Team, which is subscribed to unity in ubuntu.
> https://bugs.launchpad.net/bugs/688816
>
> Title:
>  Don't create windows over the panel
>
> Status in Unity:
>  Confirmed
> Status in “unity” package in Ubuntu:
>  Confirmed
>
> Bug description:
>  Binary package hint: unity
>
> Now that Unity has intellihide, when I open a window the system seems to think that the space over Unity's launcher is free, and opens some windows on it, therefore hiding the launcher.
>
> I don't think this should happen. The launcher should hide if the user moves a window over it, but not without user intervention.
>
>

Launcher plugin should only set the _NET_WM_STRUT property if it is
actually visible, and the strut property should automatically go away
once a window is maximized or another intellihide case is activated.

>

--
Sam Spilsbury

tags: added: bitesize
Changed in unity:
importance: Undecided → Medium
Mark Shuttleworth (sabdfl) wrote :

We need to talk about placement :-)

First, when we open a new window which can easily fit in the space with
the launcher, we should definitely avoid the launcher space. Coming up
underneath the overlay launcher just feels like a mistake.

Second, we should try to find the space we can cover the least important
stuff, i.e. cover the least of the active window. I'm not sure how to
put this in words, but I think we can really refine the algorithms we're
using.

 status confirmed
 importance medium

Mark

Changed in unity (Ubuntu):
importance: Undecided → Medium

The smart placement,algorithm already finds the most inactive space to
put windows. Also the launcher should set the strut property when out
and unset it on maximize.

On 12/12/10, Mark Shuttleworth <email address hidden> wrote:
>
> We need to talk about placement :-)
>
> First, when we open a new window which can easily fit in the space with
> the launcher, we should definitely avoid the launcher space. Coming up
> underneath the overlay launcher just feels like a mistake.
>
> Second, we should try to find the space we can cover the least important
> stuff, i.e. cover the least of the active window. I'm not sure how to
> put this in words, but I think we can really refine the algorithms we're
> using.
>
> status confirmed
> importance medium
>
> Mark
>
>
> ** Changed in: unity (Ubuntu)
> Importance: Undecided => Medium
>
> --
> You received this bug notification because you are a member of Unity
> Team, which is subscribed to unity in ubuntu.
> https://bugs.launchpad.net/bugs/688816
>
> Title:
> Don't create windows over the panel
>
> Status in Unity:
> Confirmed
> Status in “unity” package in Ubuntu:
> Confirmed
>
> Bug description:
> Binary package hint: unity
>
> Now that Unity has intellihide, when I open a window the system seems to
> think that the space over Unity's launcher is free, and opens some windows
> on it, therefore hiding the launcher.
>
> I don't think this should happen. The launcher should hide if the user moves
> a window over it, but not without user intervention.
>
>
>

--
Sent from my mobile device

Sam Spilsbury

I also noticed that a few windows (such as Chromium on first open) were positioned such that the Title bar of the unmaximized window was behind and above the top panel. You might factor a "top boundary" into this as well since most people would not know how to move a window like this via Alt+Click and Drag.

Jason Smith (jassmith) wrote :

setting the struts is not the proper solution here. There is nothing in terms of freedesktop wm spec that covers something like the intellihide case. Struts effect both maximized windows and placement. We wish only to restrain initial placement. We should be proposing something along the lines of "soft struts". The launcher would set a soft strut that would encourage initial window placement outside of the strut, but not be a strict enforcement as in the panel case.

seeker5528 (seeker5528) wrote :

"The launcher would set a soft strut that would encourage initial window placement outside of the strut, but not be a strict enforcement as in the panel case."

There is a secondary issue. There should be a sticky spot at the edge of the panel so you can easily drag a window up next to the panel and drop it to butt against the panel without causing the panel to be hidden, but also allowing you to continue dragging to the edge of the screen if you really want the window next to the edge similar to the way you might have a sticky spot at the edge of the screen so you can easily butt the window to the edge of the screen, while still allowing you to continue dragging the window so it is partially off screen if you wish.

Later, Seeker

Sam Spilsbury (smspillaz) wrote :

So really what can be done here is that unityshell.cpp can wrap CompWindow::place (eg by implementing a UnityWindow::place (CompPoint &p) {} function) and that can check if the window overlaps the launcher area and instead places it just outside the panel.

It is relatively bitesized.

Omer Akram (om26er) on 2011-01-25
summary: - Don't create windows over the panel
+ Don't create windows over the launcher
Sam Spilsbury (smspillaz) wrote :

Ok, on second looks it is not very relatively bitesized at all. I'll need to think about a proper interface for this in that case

Jorge O. Castro (jorge) on 2011-02-18
tags: removed: bitesize
Omer Akram (om26er) wrote :

this affects unity-2d since auto/intelli hide is in place

Changed in unity-2d:
status: New → Confirmed
Neil J. Patel (njpatel) on 2011-03-17
Changed in unity:
assignee: nobody → Alex Launi (alexlauni)
milestone: none → 3.6.8
Didier Roche (didrocks) on 2011-03-24
Changed in unity:
milestone: 3.6.8 → 3.8
Didier Roche (didrocks) on 2011-03-28
Changed in unity:
milestone: 3.8 → 3.8.2
Vide (vide80) wrote :

I'd like to ask that even when the user maximezes the window, it should not overlap the launcher area (thus making it hide) just as it doesn't overlap the menu bar. Should I open a new bug or this is the right place to ask such a thing?

vide, you could just turn of the auto-hide feature in ccsm. And I don't
think there is any need to report a bug for that :)

Changed in unity-2d:
importance: Undecided → Medium
Alex Launi (alexlauni) on 2011-03-29
Changed in unity:
status: Confirmed → In Progress
Changed in compiz (Ubuntu):
status: New → Confirmed
importance: Undecided → Medium
Alex Launi (alexlauni) on 2011-03-30
Changed in unity:
status: In Progress → Fix Committed
Changed in unity (Ubuntu):
status: Confirmed → Fix Committed
Didier Roche (didrocks) on 2011-04-01
Changed in unity:
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :
Download full text (5.9 KiB)

This bug was fixed in the package unity - 3.8.2-0ubuntu1

---------------
unity (3.8.2-0ubuntu1) natty; urgency=low

  * New upstream release.
    - compiz crashed with SIGSEGV in std::_List_node_base::_M_hook()
      (LP: #711916)
    - New window tracking system breaks in the case where windows try to
      restack relative to destroyed windows that were never mapped
      (LP: #723014)
    - does not display icons until hovered (LP: #726033)
    - Unity Launcher has black spaces where icons should be (LP: #729353)
    - compiz crashed with SIGSEGV in sigc::internal::signal_emit0<void,
      sigc::nil>::emit() (LP: #729715)
    - compiz crashed with SIGSEGV in SimpleLauncherIcon::OnIconThemeChanged()
      (LP: #741652)
    - compiz crashed with SIGSEGV in free() (LP: #738864)
    - compiz crashed with SIGSEGV in g_closure_invoke() (LP: #741674)
    - compiz crashed with SIGSEGV in free() (LP: #742300)
    - Unity can't get touch the touch initialization signals from GEIS
      (LP: #742555)
    - Windows that reparent away from the root before they are mapped can
      cause other windows to become invisible (and compiz to crash)
      (LP: #743011)
    - compiz crashed with SIGSEGV in gdk_cairo_set_source_pixbuf()
      (LP: #744231)
    - [dash] Keyboard navigation not implemented as specified (LP: #608132)
    - xterms broken in unity (LP: #692463)
    - Unity opens application menu on Alt+F10 shortcut (LP: #722674)
    - First four items in Dash begin "Find" "Find" "Find" "Find" (LP: #729002)
    - Increase the size of the top left Launcher reveal area from 1px to a
      slightly larger triangle that comes out of the top left corner
      (LP: #736034)
    - Add a test case for invisible windows regressions (LP: #736876)
    - Re-sync with xquerytree to avoid stacking order issues (LP: #740465)
    - Keyboard navigation: quicklist not opening for Trash launcher item
      (LP: #741793)
    - Wrong window moves (LP: #741656)
    - compiz crashed with SIGSEGV in
      SimpleLauncherIcon::ActivateLauncherIcon() (LP: #742110)
    - Combo in the search bar did not disappear after the places was closed
      (LP: #742712)
    - Expo doesn't quit reliably when using keynav or shortcut (LP: #744196)
    - Make the BFB icon turn blue when an application goes urgent
      (LP: #744973)
    - Launcher - increase "launcher reveal %" for 'Fade and slide' launcher
      reveal transition to 65% (LP: #745602)
    - Arrows do not fade out with rest of launcher durring DND (LP: #746811)
    - Don't create windows over the launcher (LP: #688816)
    - Launcher - Indicate which application is currently focused with a
      glowing Launcher icon (LP: #676604)
    - Unity Grid is broken for multi-monitor setups (LP: #709221)
    - dynamic quicklists are not working (LP: #729074)
    - When windows open for the first time they should not hide the launcher
      (LP: #723878)
    - it is still possible to quit unity from the panel (LP: #733725)
    - Selection does not fit small icons in Unity Dash (LP: #735746)
    - Unmounting media gives no error when failed (LP: #737633)
    - ATI/fglrx workaround patch (LP: #740298)
    - "Files & Folders" tooltip say...

Read more...

Changed in unity (Ubuntu):
status: Fix Committed → Fix Released
Nate Wiebe (natew) wrote :

Still not fixed. When opening terminal, it opens 1px too far to the left. So the condition used for opening new applications is 1px off.

Jason Smith (jassmith) wrote :

I fixed this in trunk, marking fix committed

Changed in unity:
milestone: 3.8.2 → none
status: Fix Released → Fix Committed
Changed in unity (Ubuntu):
assignee: nobody → Jason Smith (jassmith)
status: Fix Released → Fix Committed
Changed in unity:
assignee: Alex Launi (alexlauni) → Jason Smith (jassmith)
milestone: none → 3.8.4
Angeloribas (angeloribas) wrote :

The problem persist, but in a slightly different way. Now the title bar of the windows are appearing under the panel (see pics for more detail). Some windows also appear slightly under the panel when maximised (eg 'compiz csm').

Changed in unity-2d:
importance: Medium → High
Didier Roche (didrocks) on 2011-04-07
Changed in unity:
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :
Download full text (5.7 KiB)

This bug was fixed in the package unity - 3.8.4-0ubuntu1

---------------
unity (3.8.4-0ubuntu1) natty; urgency=low

  * New upstream release.
    - [fglrx] compiz crashed with SIGSEGV in nux::IOpenGLSurface::UnlockRect()
      (LP: #685682)
    - SIGSEGV in g_atomic_int_get (LP: #688803)
    - unity-panel-service crashed with SIGSEGV in bamf_factory_view_for_path()
      (LP: #717684)
    - New window tracking system breaks in the case where windows try to
      restack relative to destroyed windows that were never mapped
      (LP: #723014)
    - Numpad 'Enter' doesn't work on highlighted items in dash, places-files and
      places-apps (LP: #741615)
    - compiz crashed with SIGSEGV in free() (LP: #738864)
    - compiz crashed with SIGSEGV in g_closure_invoke() (LP: #741674)
    - compiz crashed with SIGSEGV in CompWindow::id() (LP: #742028)
    - Windows that reparent away from the root before they are mapped can
      cause other windows to become invisible (and compiz to crash)
      (LP: #743011)
    - compiz crashed with SIGABRT in raise() (LP: #743414)
    - compiz crashed with SIGSEGV in g_object_get_qdata() (LP: #742905)
    - compiz crashed with SIGSEGV in g_closure_invoke() (LP: #748033)
    - compiz crashed with SIGSEGV in CompScreen::dpy() (LP: #751372)
    - compiz crashed with SIGABRT in __kernel_vsyscall() (LP: #744867)
    - unity-window-decorator crashed with SIGSEGV in gdk_window_get_events()
      (LP: #725284)
    - Missing icons in app launcher (LP: #728393)
    - Multiple quick clicks on launcher icon with multiple windows completely
      crashes Unity (LP: #731790)
    - Add a test case for invisible windows regressions (LP: #736876)
    - Re-sync with xquerytree to avoid stacking order issues (LP: #740465)
    - Wrong window moves (LP: #741656)
    - compiz crashed with SIGSEGV in g_cclosure_marshal_VOID__VOID()
      (LP: #742280)
    - panel superposition (LP: #742859)
    - unity-window-decorator doesn't start on secondary X session
      (LP: #730495)
    - Unity Launcher stops autohiding and is not responsive (LP: #744325)
    - dash categories dropdown menu leaves "ghost" on desktop (LP: #746800)
    - new dialogs open close enough of the launcher to make hide (LP: #747302)
    - dnd from the application place to the launcher works only once
      (LP: #747316)
    - compiz crashed with SIGSEGV in CompWindow::id() while opening tcl/tk
      interface of R (LP: #747439)
    - minimize animates window fading to the top left corner (ubuntu symbol)
      (LP: #747765)
    - Spread - Clicking on a app icon to spread the windows must always show
      all the windows, regardless of whether or not some of the windows are
      minimised (LP: #750349)
    - Launcher - Show visual de-coupling of Launcher app icons (LP: #751196)
    - unity-window-decorator crashed with SIGSEGV in event_filter_func()
      (LP: #748317)
    - Pressing Super-W to switch windows also presents Dash (LP: #753453)
    - Don't create windows over the launcher (LP: #688816)
    - Unity Grid is broken for multi-monitor setups (LP: #709221)
    - F10 key does not move focus to indicators when on the desktop.
      (LP: #727548)
    - dynamic ...

Read more...

Changed in unity (Ubuntu):
status: Fix Committed → Fix Released
Alex Launi (alexlauni) on 2011-04-09
Changed in unity:
assignee: Jason Smith (jassmith) → Alex Launi (alexlauni)
Changed in unity (Ubuntu):
assignee: Jason Smith (jassmith) → Alex Launi (alexlauni)
Patrick Dickey (pdickeybeta) wrote :

I realize that this is listed as "fixed Released", however on a brand new upgrade to 11.04, my windows all open up underneath the Unity Launcher (regardless of whether I've repositioned them or not). This is under the "Ubuntu" login session (so I'm assuming that it's under Unity, and not Unity-2D).

Specifications of my computer are:
Toshiba Satellite A105-S2194
ATI Mobile X200 video
Intel Celeron 430 processor
2GB RAM

Have a great day:)
Patrick.

Omer Akram (om26er) wrote :

you are using unity-2d

On Sat, Apr 30, 2011 at 5:16 PM, Patrick Dickey
<email address hidden> wrote:
> I realize that this is listed as "fixed Released", however on a brand
> new upgrade to 11.04, my windows all open up underneath the Unity
> Launcher (regardless of whether I've repositioned them or not).  This is
> under the "Ubuntu" login session (so I'm assuming that it's under Unity,
> and not Unity-2D).
>
> Specifications of my computer are:
> Toshiba Satellite A105-S2194
> ATI Mobile X200 video
> Intel Celeron 430 processor
> 2GB RAM
>
> Have a great day:)
> Patrick.
>
> ** Attachment added: "WindowUnderUnity.jpg"
>   https://bugs.launchpad.net/ubuntu/+source/unity/+bug/688816/+attachment/2099423/+files/WindowUnderUnity.jpg
>
> --
> You received this bug notification because you are subscribed to unity
> in Ubuntu.
> https://bugs.launchpad.net/bugs/688816
>
> Title:
>  Don't create windows over the launcher
>
> Status in Unity:
>  Fix Released
> Status in Unity 2D:
>  Confirmed
> Status in “compiz” package in Ubuntu:
>  Confirmed
> Status in “unity” package in Ubuntu:
>  Fix Released
>
> Bug description:
>  Binary package hint: unity
>
>  Now that Unity has intellihide, when I open a window the system seems
>  to think that the space over Unity's launcher is free, and opens some
>  windows on it, therefore hiding the launcher.
>
>  I don't think this should happen. The launcher should hide if the user
>  moves a window over it, but not without user intervention.
>

Olivier Tilloy (osomon) wrote :

@Patrick: Omer is right, the screenshot you attached was taken running Unity-2d.

Patrick Dickey (pdickeybeta) wrote :

Thanks for the clarification. However, does that mean that there's no fix for the issue, or should I be filing a bug report somewhere else?

Have a great day:)
Patrick.

Olivier Tilloy (osomon) wrote :

@Patrick: no need for a new bug report, this one already tracks the issue for unity-2d too (see the "Confirmed" status for "unity-2d" at the top of the page). It means that there is currently no fix for it in unity-2d, but we are aware of the issue and will fix it in due course.

Olivier Tilloy (osomon) on 2011-05-02
Changed in unity-2d:
milestone: none → 3.10
Olivier Tilloy (osomon) on 2011-05-02
Changed in unity-2d:
assignee: nobody → Olivier Tilloy (osomon)
Olivier Tilloy (osomon) on 2011-05-04
Changed in unity-2d:
status: Confirmed → In Progress
Olivier Tilloy (osomon) wrote :

Pushed metacity 1:2.30.3-0ubuntu9 to ppa:unity-2d-team/unity-2d-daily for testing.

Changed in unity-2d:
status: In Progress → Fix Committed
Didier Roche (didrocks) on 2011-06-06
Changed in unity-2d (Ubuntu):
status: New → Fix Committed
Changed in unity-2d:
milestone: 3.10 → 3.8.8
Didier Roche (didrocks) on 2011-06-14
Changed in unity-2d:
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unity-2d - 3.8.8-0ubuntu1

---------------
unity-2d (3.8.8-0ubuntu1) oneiric; urgency=low

  [ Didier Roche ]
  * new upstream release:
    - [spread] Corruption when switching workspaces after windows have been
      moved to other workspaces (LP: #760787)
    - [launcher] launcher won't fully paint, corrupted view (LP: #764690)
    - [launcher] icons no longer active after an incomplete drag (LP: #768812)
    - drag from dash to launcher (LP: #662616)
    - Don't create windows over the launcher (LP: #688816)
    - [launcher] Does not reveal when hovering over the left edge of the
      screen (LP: #760537)
    - UIFe: Launcher - update launcher reveal interaction to make it more
      accessible to first time users (LP: #754583)
    - [launcher] Trash icon should indicate when it has deleted elements
      (LP: #715611)
    - When windows open for the first time they should not hide the launcher
      (LP: #723878)
    - double clicks should be disabled on bfb/Place launcher icon/double key
      press (LP: #766776)
    - [dash][launcher] Should use real transparency when a compositing manager
      is running (LP: #794042)
    - [dash] Thunderbird icon is pixelated (LP: #767115)
    - [panel] Hovering the mouse cursor over the BFB reveals the current
      window’s menu (LP: #793403)
    - [panel] Hovering the mouse cursor away from the appmenu applet doesn’t
      hide the menu (LP: #793406)
    - unity-2d: does not parse QT_GRAPHICSSYSTEM env var (LP: #791852)
    - Cannot drag applications from dash to desktop (LP: #756614)
  * debian/control:
    - unity-2d-panel recommends the indicator, not unity-2d
    - appmenu-gtk and appmenu-qt are already provided by indicator-appmenu
    - remove other meaningless recommends
  * debian/libunity-2d-private0.install:
    - install everything in Unity2d private directory

  [ Florian Boucault ]
  * debian/unity-2d-launcher.install:
    - do not install usr/lib/qt4/imports/UnityApplications/ anylonger as all of
      UnityApplications features have been moved to the Unity2d QML plugin
      installed by libunity-2d-private0
  * debian/control:
    - unity-2d-places and unity-2d-spread do not depend on unity-2d-launcher.
      All they need is now in libunity-2d-private0.
 -- Didier Roche <email address hidden> Tue, 14 Jun 2011 16:14:18 +0200

Changed in unity-2d (Ubuntu):
status: Fix Committed → Fix Released
Patrick Dickey (pdickeybeta) wrote :

Has this fix been pushed out, so our apt-get update will catch it? And how do we tell what version of Unity we're running? I ask both of these, because as I sit here my windows still open up under the launcher (even though it's set to Autohide), and the launcher never hides, regardless of what setting I choose.

Granted, I haven't tried changing my window placement to "Center" yet. I'll try that now.

Have a great day:)
Patrick.

pelle.k (pele2) wrote :

This is not fixed (or perhaps it's a regression) in unity-2d 4.12.0-0ubuntu1, using oneiric (fully updated). Metacity still places windows under (over?) the launcher causing it to hide.
Perhaps one should kill two birds with one stone, and implement the "smart" window placement mode from compiz in metacity, and at the same time make sure no new windows occupy the space under the launcher. This would much better reflect the defaults of unity (3d).

Ugo Riboni (uriboni) wrote :

Reopening the bug for unity-2d since it was fixed in unity-2d's metacity branch but when the patch was upstreamed into ubuntu the uploader forgot to add it to the patches/series file

Changed in unity-2d:
status: Fix Released → Confirmed
Doug McMahon (mc3man) wrote :

Ugo Riboni wrote >
"Reopening the bug for unity-2d since it was fixed in unity-2d's metacity branch but when the patch was upstreamed into ubuntu the uploader forgot to add it to the patches/series file"

Thanks for bringing that up - had the bug you duped, (against unity-2d in 11.10+)
A quick rebuild of metacity, (2.34.1-1ubuntu4) oneiric, adding the patch to the series & this now works as expected with the default of hide-mode 2

Maybe metacity should be added to this report?

Doug McMahon (mc3man) on 2011-11-09
Changed in metacity (Ubuntu):
status: New → Confirmed
Florian Boucault (fboucault) wrote :

This is fixed in Unity 2D/Metacity for Precise 12.04.

Florian Boucault (fboucault) wrote :

The patch has been reactivated in both Precise and Oneiric's updates.

Changed in unity-2d:
milestone: 3.8.8 → none
status: Confirmed → Fix Released
Changed in metacity (Ubuntu):
status: Confirmed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers